'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _powerAssertRecorder = function () { function PowerAssertRecorder() { this.captured = []; } PowerAssertRecorder.prototype._capt = function _capt(value, espath) { this.captured.push({ value: value, espath: espath }); return value; }; PowerAssertRecorder.prototype._expr = function _expr(value, source) { var capturedValues = this.captured; this.captured = []; return { powerAssertContext: { value: value, events: capturedValues }, source: source }; }; return PowerAssertRecorder; }();

var _powerAssert = require('power-assert');

var _powerAssert2 = _interopRequireDefault(_powerAssert);

var _history2 = require('./history');

var _history3 = _interopRequireDefault(_history2);

var _routingTable = require('./routing-table');

var _routingTable2 = _interopRequireDefault(_routingTable);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Router = function () {
  function Router(basePath, indexRouteName, options, routeBuilderFn) {
    var _rec = new _powerAssertRecorder(),
        _rec2 = new _powerAssertRecorder();

    _classCallCheck(this, Router);

    if (!(typeof basePath === 'string' && typeof indexRouteName === 'string')) {
      routeBuilderFn = options;
      options = indexRouteName;
      indexRouteName = basePath;
      basePath = '';
    }
    (0, _powerAssert2.default)(_rec._expr(_rec._capt(_rec._capt(typeof basePath === 'undefined' ? 'undefined' : _typeof(basePath), 'arguments/0/left') === 'string', 'arguments/0'), {
      content: 'assert(typeof basePath === \'string\', \'basePath must be a string\')',
      filepath: 'src/router.js',
      line: 19
    }), 'basePath must be a string');
    (0, _powerAssert2.default)(_rec2._expr(_rec2._capt(_rec2._capt(typeof indexRouteName === 'undefined' ? 'undefined' : _typeof(indexRouteName), 'arguments/0/left') === 'string', 'arguments/0'), {
      content: 'assert(typeof indexRouteName === \'string\', \'indexRouteName must be a string\')',
      filepath: 'src/router.js',
      line: 20
    }), 'indexRouteName must be a string');
    this._basePath = '/' + basePath;
    this._routingTable = new _routingTable2.default(basePath, indexRouteName, options, routeBuilderFn);

    this._isClientSide = (typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object';
    if (this._isClientSide) {
      this._navigationListeners = [];
      this._interceptLinkClicks = false;
      this.onClick = this._onClick.bind(this);
      // globals -> locals for testing
      this._document = window.document;
      this._location = window.location;
    }
  }

  /* Universal methods */

  _createClass(Router, [{
    key: 'getRouteUrl',
    value: function getRouteUrl(route) {
      return this._externalizeUrl(this._routingTable.getUrlForRoute(route));
    }
  }, {
    key: 'getUrlRoute',
    value: function getUrlRoute(url) {
      return this._routingTable.getRouteForUrl(this._internalizeUrl(url));
    }
  }, {
    key: 'isRouteEqual',
    value: function isRouteEqual(routeX, routeY) {
      var urlX = this.getRouteUrl(routeX);
      var urlY = this.getRouteUrl(routeY);
      return !!(urlX && urlY && urlX === urlY);
    }
  }, {
    key: 'isRouteWithin',
    value: function isRouteWithin(routeX, routeY) {
      var urlX = this.getRouteUrl(routeX);
      var urlY = this.getRouteUrl(routeY);
      if (!(urlX && urlY && urlX !== urlY)) {
        return false;
      }

      var pathX = (0, _util.getPath)(urlX);
      var pathY = (0, _util.getPath)(urlY);
      var queryY = (0, _util.getQuery)(urlY);
      if (!queryY) {
        return pathX.indexOf(pathY) === 0;
      }

      var queryParamsX = (0, _util.decodeQueryParams)((0, _util.getQuery)(urlX));
      return (0, _util.isProperSubset)((0, _util.decodeQueryParams)(queryY), queryParamsX);
    }

    /* Client-side methods */

  }, {
    key: '_clientMethod',
    value: function _clientMethod(methodName) {
      var _rec3 = new _powerAssertRecorder();

      var isClientSide = this._isClientSide;
      (0, _powerAssert2.default)(_rec3._expr(_rec3._capt(isClientSide, 'arguments/0'), {
        content: 'assert(isClientSide, `router.${methodName} cannot be called server-side`)',
        filepath: 'src/router.js',
        line: 73
      }), 'router.' + methodName + ' cannot be called server-side');
    }
  }, {
    key: '_history',
    value: function _history() {
      var _this = this;

      if (this._historyInstance) {
        return this._historyInstance;
      }

      this._historyInstance = new _history3.default(function (path) {
        var route = _this.getUrlRoute(path);
        _this.warnOnNavigation(false);
        _this._emitNavigation(route);
      });

      this._historyInstance.attach();
    }
  }, {
    key: '_externalizeUrl',
    value: function _externalizeUrl(url) {
      if (!this._isClientSide) {
        return url;
      }
      this._history().externalizeUrl(this._basePath, url);
    }
  }, {
    key: '_internalizeUrl',
    value: function _internalizeUrl(url) {
      if (!this._isClientSide) {
        return url;
      }
      this._history().internalizeUrl(this._basePath, url);
    }
  }, {
    key: '_navigateTo',
    value: function _navigateTo(path, title, replace) {
      title = title || this._document.title;
      replace = replace || false;
      this._history().update(path, title, replace);
    }
  }, {
    key: '_emitNavigation',
    value: function _emitNavigation(route) {
      this._navigationListeners.forEach(function (f) {
        return f(route);
      });
    }
  }, {
    key: 'onNavigation',
    value: function onNavigation(listener) {
      var _rec4 = new _powerAssertRecorder();

      this._clientMethod('onNavigation');
      (0, _powerAssert2.default)(_rec4._expr(_rec4._capt(_rec4._capt(typeof listener === 'undefined' ? 'undefined' : _typeof(listener), 'arguments/0/left') === 'function', 'arguments/0'), {
        content: 'assert(typeof listener === \'function\', \'listener must be a function\')',
        filepath: 'src/router.js',
        line: 116
      }), 'listener must be a function');
      this._navigationListeners.push(listener);
    }
  }, {
    key: 'offNavigation',
    value: function offNavigation(listener) {
      var _rec5 = new _powerAssertRecorder();

      this._clientMethod('offNavigation');
      (0, _powerAssert2.default)(_rec5._expr(_rec5._capt(_rec5._capt(typeof listener === 'undefined' ? 'undefined' : _typeof(listener), 'arguments/0/left') === 'function', 'arguments/0'), {
        content: 'assert(typeof listener === \'function\', \'listener must be a function\')',
        filepath: 'src/router.js',
        line: 122
      }), 'listener must be a function');
      this._navigationListeners = this._navigationListeners.filter(function (x) {
        return x !== listener;
      });
    }
  }, {
    key: 'navigateTo',
    value: function navigateTo(route) {
      var _rec6 = new _powerAssertRecorder(),
          _rec7 = new _powerAssertRecorder();

      this._clientMethod('navigateTo');
      (0, _powerAssert2.default)(_rec6._expr(_rec6._capt(_rec6._capt(_typeof(_rec6._capt(_rec6._capt(route, 'arguments/0/left/argument/object').route, 'arguments/0/left/argument')), 'arguments/0/left') === 'string', 'arguments/0'), {
        content: 'assert(typeof route.route === \'string\', \'route must be a string\')',
        filepath: 'src/router.js',
        line: 129
      }), 'route must be a string');
      var path = this.getRouteUrl(route);
      (0, _powerAssert2.default)(_rec7._expr(_rec7._capt(path, 'arguments/0'), {
        content: 'assert(path, `route not found for ${JSON.stringify(route)}`)',
        filepath: 'src/router.js',
        line: 131
      }), 'route not found for ' + JSON.stringify(route));
      this._navigateTo(path, null, route.replace);
    }
  }, {
    key: 'warnOnNavigation',
    value: function warnOnNavigation(message) {
      this._navigationWarning = message;
      if (!this._navigationWarning || this._beforeUnload) {
        return;
      }
      var self = this;
      this._beforeUnload = function _beforeUnload(e) {
        if (self._navigationWarning) {
          var _message = self._navigationWarning === true ? '' : self._navigationWarning;
          e.returnValue = _message;
          return _message;
        }
      };
      this._document.addEventListener('beforeunload', this._beforeUnload);
    }
  }, {
    key: 'initialize',
    value: function initialize() {
      this._clientMethod('initialize');
      this._emitNavigation(this.getCurrentRoute());
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this._clientMethod('destroy');
      this.warnOnNavigation(false);
      this._document.removeEventListener('beforeunload', this._beforeUnload);
      this.interceptLinkClicks(false);
      this._history().detach();
    }
  }, {
    key: '_onClick',
    value: function _onClick(event) {
      this._clientMethod('onClick');
      var target = event.target;

      while (target && target.tagName.toUpperCase() !== 'A') {
        target = target.parentNode;
      }
      if (!(target && target.href && target.target !== '_blank')) {
        return;
      }

      var origin = this._location.origin;

      var path = target.href.slice(origin.length);
      if (path.indexOf(this._basePath) !== 0) {
        return;
      }

      event.preventDefault();
      this._navigateTo(path, target.title);
    }
  }, {
    key: 'interceptLinkClicks',
    value: function interceptLinkClicks(attach) {
      this._clientMethod('interceptLinkClicks');
      if (this._interceptLinkClicks) {
        if (!attach) {
          this._document.removeEventListener('click', this.onClick);
          this._interceptLinkClicks = false;
        }
        return;
      }
      this._document.addEventListener('click', this.onClick);
      this._interceptLinkClicks = true;
    }
  }, {
    key: 'getCurrentRoute',
    value: function getCurrentRoute() {
      this._clientMethod('getCurrentRoute');
      var _location = this._location,
          href = _location.href,
          origin = _location.origin;

      var path = href.slice(origin.length);
      return this.getUrlRoute(path);
    }
  }, {
    key: 'isRouteActive',
    value: function isRouteActive(route) {
      this._clientMethod('isRouteActive');
      return this.isRouteEqual(this.getCurrentRoute(), route);
    }
  }, {
    key: 'isCurrentRouteWithin',
    value: function isCurrentRouteWithin(route) {
      this._clientMethod('isCurrentRouteWithin');
      return this.isRouteWithin(this.getCurrentRoute(), route);
    }
  }]);

  return Router;
}();

exports.default = Router;
//# sourceMappingURL=router.js.map
