'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.routeParam = exports.route = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _powerAssertRecorder = function () { function PowerAssertRecorder() { this.captured = []; } PowerAssertRecorder.prototype._capt = function _capt(value, espath) { this.captured.push({ value: value, espath: espath }); return value; }; PowerAssertRecorder.prototype._expr = function _expr(value, source) { var capturedValues = this.captured; this.captured = []; return { powerAssertContext: { value: value, events: capturedValues }, source: source }; }; return PowerAssertRecorder; }();

exports.recur = recur;
exports.buildChildren = buildChildren;
exports.routeSplat = routeSplat;
exports.routeRedirect = routeRedirect;
exports.buildTableIndex = buildTableIndex;
exports.findPathRoute = findPathRoute;
exports.buildUrlRoute = buildUrlRoute;
exports.pathJoin = pathJoin;
exports.buildRouteUrl = buildRouteUrl;

var _powerAssert = require('power-assert');

var _powerAssert2 = _interopRequireDefault(_powerAssert);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function recur(func) {
  return function _recur(x, y, options, callback) {
    if (options === void 0) {
      return _recur(x, y, {});
    }
    if (typeof options === 'function') {
      return _recur(x, y, {}, options);
    }
    return func(x, y, options, callback);
  };
}

var route = exports.route = recur(function (path, route, options, routeBuilderFn) {
  var _rec = new _powerAssertRecorder(),
      _rec2 = new _powerAssertRecorder();

  var children = buildChildren(routeBuilderFn);
  (0, _powerAssert2.default)(_rec._expr(_rec._capt(_rec._capt(_rec._capt(path, 'arguments/0/left/callee/object').charAt(0), 'arguments/0/left') !== '/', 'arguments/0'), {
    content: 'assert(path.charAt(0) !== \'/\', `Path segment "${path}" should not start with "/"`)',
    filepath: 'src/routing-table.js',
    line: 24
  }), 'Path segment "' + path + '" should not start with "/"');
  (0, _powerAssert2.default)(_rec2._expr(_rec2._capt(_rec2._capt(_rec2._capt(path, 'arguments/0/left/callee/object').charAt(_rec2._capt(_rec2._capt(_rec2._capt(path, 'arguments/0/left/arguments/0/left/object').length, 'arguments/0/left/arguments/0/left') - 1, 'arguments/0/left/arguments/0')), 'arguments/0/left') !== '/', 'arguments/0'), {
    content: 'assert(path.charAt(path.length - 1) !== \'/\', `Path segment "${path}" should not end with "/"`)',
    filepath: 'src/routing-table.js',
    line: 25
  }), 'Path segment "' + path + '" should not end with "/"');
  return { type: 'route', path: path, route: route, options: options, children: children };
});

var routeParam = exports.routeParam = recur(function (param, route, options, routeBuilderFn) {
  var children = buildChildren(routeBuilderFn);
  return { type: 'param', param: param, route: route, options: options, children: children };
});

function buildChildren(routeBuilderFn) {
  var children = [];
  if (routeBuilderFn) {
    var _rec3 = new _powerAssertRecorder(),
        _rec4 = new _powerAssertRecorder();

    (0, _powerAssert2.default)(_rec3._expr(_rec3._capt(_rec3._capt(typeof routeBuilderFn === 'undefined' ? 'undefined' : _typeof(routeBuilderFn), 'arguments/0/left') === 'function', 'arguments/0'), {
      content: 'assert(typeof routeBuilderFn === \'function\', \'routeBuilderFn must be a function\')',
      filepath: 'src/routing-table.js',
      line: 37
    }), 'routeBuilderFn must be a function');
    children = routeBuilderFn(route);
    (0, _powerAssert2.default)(_rec4._expr(_rec4._capt(_rec4._capt(Array, 'arguments/0/callee/object').isArray(_rec4._capt(children, 'arguments/0/arguments/0')), 'arguments/0'), {
      content: 'assert(Array.isArray(children), \'routeBuilderFn must return an array\')',
      filepath: 'src/routing-table.js',
      line: 39
    }), 'routeBuilderFn must return an array');
  }
  return children.map(function (child) {
    return (
      // nested router support
      child._routingTable instanceof RoutingTable ? child._routingTable.route : child
    );
  });
}

function routeSplat(route, options) {
  options = options || {};
  return { type: 'splat', route: route, options: options };
}

function routeRedirect(path, route) {
  return { type: 'redirect', path: path, route: route };
}

route.param = routeParam;
route.splat = routeSplat;
route.redirect = routeRedirect;

function buildTableIndex(table) {
  var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var path = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  for (var i = 0; i < table.length; i++) {
    var _rec5 = new _powerAssertRecorder(),
        _rec6 = new _powerAssertRecorder(),
        _rec7 = new _powerAssertRecorder();

    var _route = table[i];
    if (_route.type === 'redirect') {
      continue;
    }

    (0, _powerAssert2.default)(_rec5._expr(_rec5._capt(_rec5._capt(_route, 'arguments/0/callee/object').hasOwnProperty('route'), 'arguments/0'), {
      content: 'assert(route.hasOwnProperty(\'route\'), \'Route name not provided\')',
      filepath: 'src/routing-table.js',
      line: 67
    }), 'Route name not provided');
    (0, _powerAssert2.default)(_rec6._expr(_rec6._capt(_rec6._capt(_typeof(_rec6._capt(_rec6._capt(_route, 'arguments/0/left/argument/object').route, 'arguments/0/left/argument')), 'arguments/0/left') === 'string', 'arguments/0'), {
      content: 'assert(typeof route.route === \'string\', `Route name must be a string, not ${route.route}`)',
      filepath: 'src/routing-table.js',
      line: 68
    }), 'Route name must be a string, not ' + _route.route);

    var routePath = path.concat(_route);

    var existingRoute = index[_route.route];
    (0, _powerAssert2.default)(_rec7._expr(_rec7._capt(!_rec7._capt(existingRoute, 'arguments/0/argument'), 'arguments/0'), {
      content: 'assert(!existingRoute, `Route "${route.route}" already registered as ${JSON.stringify(existingRoute)}`)',
      filepath: 'src/routing-table.js',
      line: 73
    }), 'Route "' + _route.route + '" already registered as ' + JSON.stringify(existingRoute));
    index[_route.route] = routePath;

    if (Array.isArray(_route.children)) {
      buildTableIndex(_route.children, index, routePath);
    }
  }
  return index;
}

function findPathRoute(route, path) {
  if (path.charAt(0) === '/') {
    path = path.slice(1);
  }
  var segment = void 0,
      childPath = void 0,
      routeParams = void 0;
  switch (route.type) {
    case 'splat':
      return { route: route, path: '' };
    case 'redirect':
      return route.path === path && { route: route, path: path };
    case 'param':
      var nextSep = path.indexOf('/');
      segment = nextSep !== -1 ? path.slice(0, nextSep) : path;
      routeParams = _defineProperty({}, route.param, segment);
      childPath = path.slice(segment.length);
      break;
    case 'route':
      if (path.indexOf(route.path) !== 0) {
        return;
      }
      segment = path.slice(0, route.path.length);
      childPath = path.slice(segment.length);
      break;
    default:
      (0, _powerAssert2.default)(false, 'Invalid route type: ' + route.type);
  }

  var isTerminal = function isTerminal(x) {
    return !x || x === '/';
  };
  if (isTerminal(childPath)) {
    return { route: route, path: path, routeParams: routeParams };
  }

  var children = route.children;

  if (!Array.isArray(children)) {
    return;
  }

  var innerResult = void 0;
  for (var j = 0; j < children.length; j++) {
    var childRoute = children[j];
    innerResult = findPathRoute(childRoute, childPath);
    if (innerResult) {
      break;
    }
  }
  if (!innerResult) {
    return;
  }

  var result = {
    path: '/' + segment + innerResult.path,
    route: innerResult.route,
    routeParams: _extends({}, routeParams, innerResult.routeParams)
  };
  return result;
}

function buildUrlRoute(table, index, url) {
  var path = (0, _util.getPath)(url);
  var result = findPathRoute(table, path);
  if (!result) {
    return null;
  }

  var route = result.route;

  var _ref = route.options || {},
      deserializeQuery = _ref.deserializeQuery,
      queryDefaults = _ref.queryDefaults;

  var query = (0, _util.decodeQueryParams)((0, _util.getQuery)(url));
  var queryData = deserializeQuery ? deserializeQuery(query) : query;
  var queryParams = Object.assign({}, queryDefaults, queryData);

  var splat = '';
  var searchPath = result.path,
      _result$routeParams = result.routeParams,
      routeParams = _result$routeParams === undefined ? {} : _result$routeParams;

  if (route.type === 'redirect') {
    var _rec8 = new _powerAssertRecorder(),
        _rec9 = new _powerAssertRecorder();

    var newRoute = route.route;

    if (typeof newRoute === 'function') {
      newRoute = newRoute({ routeParams: routeParams, queryParams: queryParams });
    }
    var newRouteName = newRoute.route;
    (0, _powerAssert2.default)(_rec8._expr(_rec8._capt(newRouteName, 'arguments/0'), {
      content: 'assert(newRouteName, `Redirect for ${url} does not have a route name`)',
      filepath: 'src/routing-table.js',
      line: 159
    }), 'Redirect for ' + url + ' does not have a route name');
    var nextRoute = index[newRouteName];
    (0, _powerAssert2.default)(_rec9._expr(_rec9._capt(nextRoute, 'arguments/0'), {
      content: 'assert(nextRoute, `Following redirect for ${url}, route "${newRouteName}" was not found`)',
      filepath: 'src/routing-table.js',
      line: 161
    }), 'Following redirect for ' + url + ', route "' + newRouteName + '" was not found');

    var _ref2 = nextRoute.options || {},
        _queryDefaults = _ref2.queryDefaults;

    return _extends({
      splat: splat,
      routeParams: {}
    }, newRoute, {
      queryParams: _extends({}, _queryDefaults, newRoute.queryParams),
      redirect: true
    });
  }

  if (route.type === 'splat') {
    splat = path.slice(searchPath.length);
  }

  return {
    route: route.route,
    splat: splat,
    routeParams: routeParams,
    queryParams: queryParams
  };
}

function pathJoin(a, b) {
  var sep = '/';
  if (a.charAt(a.length - 1) === sep) {
    a = a.slice(0, -1);
  }
  if (b.charAt(0) === sep) {
    b = b.slice(1);
  }
  return '' + a + sep + b;
}

function buildRouteUrl(routePath, _ref3) {
  var routeName = _ref3.route,
      splat = _ref3.splat,
      routeParams = _ref3.routeParams,
      queryParams = _ref3.queryParams;

  var path = '';
  var route = void 0;
  for (var i = 0; i < routePath.length; i++) {
    route = routePath[i];
    if (route.type === 'splat') {
      path = pathJoin(path, splat || '');
      break;
    }
    if (route.type === 'param') {
      var _rec10 = new _powerAssertRecorder();

      var paramName = route.param;
      (0, _powerAssert2.default)(_rec10._expr(_rec10._capt(_rec10._capt(routeParams, 'arguments/0/callee/object').hasOwnProperty(_rec10._capt(paramName, 'arguments/0/arguments/0')), 'arguments/0'), {
        content: 'assert(routeParams.hasOwnProperty(paramName), `Route name "${routeName}" must be called with route paramter "${paramName}"`)',
        filepath: 'src/routing-table.js',
        line: 206
      }), 'Route name "' + routeName + '" must be called with route paramter "' + paramName + '"');
      path = pathJoin(path, routeParams[paramName]);
      continue;
    }

    path = pathJoin(path, route.path);
    if (route.type === 'redirect') {
      break;
    }
  }

  var _ref4 = route.options || {},
      serializeQuery = _ref4.serializeQuery,
      queryDefaults = _ref4.queryDefaults;

  var fixedQuery = serializeQuery ? serializeQuery(queryParams || {}) : queryParams;
  var shortQuery = (0, _util.diffFrom)(fixedQuery, queryDefaults);
  var query = (0, _util.encodeQueryParams)(shortQuery);
  return path + query;
}

var RoutingTable = function () {
  function RoutingTable(basePath, indexRouteName, options, routeBuilderFn) {
    _classCallCheck(this, RoutingTable);

    this.route = route(basePath, indexRouteName, options, routeBuilderFn);
    this.index = buildTableIndex([this.route]);
  }

  _createClass(RoutingTable, [{
    key: 'getRouteForUrl',
    value: function getRouteForUrl(url) {
      return buildUrlRoute(this.route, this.index, url);
    }
  }, {
    key: 'getUrlForRoute',
    value: function getUrlForRoute(routeData) {
      var routePath = this.index[routeData.route];
      if (!routePath) {
        return null;
      }
      return buildRouteUrl(routePath, routeData);
    }
  }]);

  return RoutingTable;
}();

exports.default = RoutingTable;
//# sourceMappingURL=routing-table.js.map
