'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.diffFrom = diffFrom;
exports.isProperSubset = isProperSubset;
exports.getPath = getPath;
exports.getQuery = getQuery;
exports.decodeQueryParams = decodeQueryParams;
exports.encodeQueryParams = encodeQueryParams;
function diffFrom(obj, base) {
  if (!base) {
    return obj;
  }
  var result = {};
  for (var key in obj) {
    var val = obj[key];
    if (val !== base[key]) {
      result[key] = val;
    }
  }
  return result;
}

function isProperSubset(small, large) {
  var keyCount = 0;
  for (var key in small) {
    if (small[key] !== large[key]) {
      return false;
    }
    keyCount++;
  }
  return keyCount < Object.keys(large).length;
}

function getPath(url) {
  return url.split('?')[0];
}

function getQuery(url) {
  return url.split('?')[1];
}

function decodeQueryParams(query) {
  if (query && query.charAt(0) === '?') {
    query = query.slice(1);
  }
  if (!query) {
    return {};
  }
  return query.split('&').reduce(function (obj, pair) {
    var _pair$split = pair.split('='),
        _pair$split2 = _slicedToArray(_pair$split, 2),
        key = _pair$split2[0],
        val = _pair$split2[1];

    obj[decodeURIComponent(key)] = decodeURIComponent(val);
    return obj;
  }, {});
}

function encodeQueryParams(params) {
  if (!params) {
    return '';
  }
  var keys = Object.keys(params).sort(function (a, b) {
    return a.localeCompare(b);
  });
  if (!keys.length) {
    return '';
  }
  var query = '';
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    query += '&' + encodeURIComponent(key);
    var value = params[key];
    if (value !== void 0) {
      query += '=' + encodeURIComponent(value);
    }
  }
  return '?' + query.slice(1);
}
//# sourceMappingURL=util.js.map
